﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Charts;
using _2012_05_25_ChartSample;
using System.Diagnostics;
using Infragistics.Controls;
using Infragistics.Windows;

namespace DataChartZooming
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        List<EnergyProduction> pointsInView;
        XamZoombar xzb;
        Border panelChildren;
        public MainWindow()
        {
            InitializeComponent();
            pointsInView = new List<EnergyProduction>();
            dataSample = new EnergyProductionDataSample();

            yAxis = new NumericYAxis();
            xAxis = new CategoryXAxis();
            xAxis.ItemsSource = dataSample;
            xAxis.Label = "{Country}";
            this.DataChart.Axes.Add(xAxis);
            this.DataChart.Axes.Add(yAxis);

            PointSeries series = new PointSeries();
            series.ItemsSource = dataSample;
            series.ValueMemberPath = "Coal";
            series.Title = "Coal";
            series.XAxis = xAxis;
            series.YAxis = yAxis;
            this.DataChart.Series.Add(series);
             
        }

        NumericYAxis yAxis; CategoryXAxis xAxis; EnergyProductionDataSample dataSample;

        private void DataChart_Loaded(object sender, RoutedEventArgs e)
        {
            ContentPresenter cp = Infragistics.Windows.Utilities.GetDescendantFromType(sender as DependencyObject, typeof(ContentPresenter), false) as ContentPresenter;
            Panel chartAreaPanel = cp.Content as Panel;
            panelChildren = chartAreaPanel.Children[2] as Border;
            Grid grid = Infragistics.Windows.Utilities.GetDescendantFromType(panelChildren as DependencyObject, typeof(Grid), false) as Grid;
            Canvas canvas = grid.Children[3] as Canvas;
            grid.Children.RemoveAt(3);
            xzb = new XamZoombar() {Range = new Range() { Minimum = 0.25, Maximum = 0.75 }, Background = null, Name = "zoomBar", Height = panelChildren.Height - 500, Width = panelChildren.Width - 100 };
            xzb.LayoutUpdated += new EventHandler(xzb_LayoutUpdated);
            xzb.Loaded += new RoutedEventHandler(xzb_Loaded);
            var v = Utilities.GetDescendantFromType(xzb as DependencyObject, typeof(ContentControl), false);
            xzb.HorizontalPreviewContent = canvas;
            grid.Children.Add(xzb);
        }

        void xzb_LayoutUpdated(object sender, EventArgs e)
        {
                Utilities.GetDescendantFromName(xzb as DependencyObject, "HorizontalThumbElement").Height = panelChildren.ActualHeight - 30;
                Utilities.GetDescendantFromName(xzb as DependencyObject, "HorizontalScaleLeftElement").Height = panelChildren.ActualHeight - 30;
                Utilities.GetDescendantFromName(xzb as DependencyObject, "HorizontalScaleRightElement").Height = panelChildren.ActualHeight - 30;
        }

        void xzb_Loaded(object sender, RoutedEventArgs e)
        {
             Utilities.GetDescendantFromName(sender as DependencyObject, "HorizontalThumbElement").Height = panelChildren.ActualHeight-30;
             Utilities.GetDescendantFromName(sender as DependencyObject, "HorizontalScaleLeftElement").Height = panelChildren.ActualHeight-30;
             Utilities.GetDescendantFromName(sender as DependencyObject, "HorizontalScaleRightElement").Height = panelChildren.ActualHeight-30;
             (sender as XamZoombar).LayoutUpdated += new EventHandler(xzb_LayoutUpdated);
        }

        private void DataChart_SeriesMouseLeftButtonDown(object sender, DataChartMouseButtonEventArgs e)
        {
            MessageBox.Show("Data Point is selected");
        }

        

      
 
    }
}
